<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (7)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="the-modern-mode-use-strict">The modern mode, “use strict”</h1>
    <p>
      For a long time, JavaScript evolved without compatibility issues. New
      features were added to the language while old functionality didn’t change.
    </p>
    <p>
      That had the benefit of never breaking existing code. But the downside was
      that any mistake or an imperfect decision made by JavaScript’s creators
      got stuck in the language forever.
    </p>
    <p>
      This was the case until 2009 when ECMAScript 5 (ES5) appeared. It added
      new features to the language and modified some of the existing ones. To
      keep the old code working, most such modifications are off by default. You
      need to explicitly enable them with a special directive:
      <code>"use strict"</code>.
    </p>
    <h2 id="use-strict">“use strict”</h2>
    <p>
      The directive looks like a string: <code>"use strict"</code> or
      <code>'use strict'</code>. When it is located at the top of a script, the
      whole script works the “modern” way.
    </p>
    <p>For example:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="st">&quot;use strict&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-2" title="2"></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="co">// this code works the modern way</span></a>
<a class="sourceLine" id="cb1-4" title="4">...</a></code></pre>
    </div>
    <p>
      Quite soon we’re going to learn functions (a way to group commands), so
      let’s note in advance that <code>"use strict"</code> can be put at the
      beginning of a function. Doing that enables strict mode in that function
      only. But usually people use it for the whole script.
    </p>
    <p>
      ```<code
        >warn header="Ensure that "use strict" is at the top" Please make sure
        that</code
      >“use strict”` is at the top of your scripts, otherwise strict mode may
      not be enabled.
    </p>
    <p>Strict mode isn’t enabled here:</p>
    <p>
      ```js no-strict alert(“some code”); // “use strict” below is ignored–it
      must be at the top
    </p>
    <p>“use strict”;</p>
    <p>// strict mode is not activated</p>
    <pre><code>
Only comments may appear above `&quot;use strict&quot;`.</code></pre>
    <p>
      ``<code>warn header="There's no way to cancel</code>use strict<code
        >" There is no directive like</code
      >“no use strict”` that reverts the engine to old behavior.
    </p>
    <p>Once we enter strict mode, there’s no going back.</p>
    <pre><code>
## Browser console

When you use a [developer console](info:devtools) to run code, please note that it doesn&#39;t `use strict` by default.

Sometimes, when `use strict` makes a difference, you&#39;ll get incorrect results.

So, how to actually `use strict` in the console?

First, you can try to press `key:Shift+Enter` to input multiple lines, and put `use strict` on top, like this:

```js
&#39;use strict&#39;; &lt;Shift+Enter for a newline&gt;
//  ...your code
&lt;Enter to run&gt;</code></pre>
    <p>It works in most browsers, namely Firefox and Chrome.</p>
    <p>
      If it doesn’t, e.g. in an old browser, there’s an ugly, but reliable way
      to ensure <code>use strict</code>. Put it inside this kind of wrapper:
    </p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1">(<span class="kw">function</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="st">&quot;use strict&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb4-3" title="3"></a>
<a class="sourceLine" id="cb4-4" title="4">  <span class="co">// ...your code here...</span></a>
<a class="sourceLine" id="cb4-5" title="5"><span class="op">}</span>)()<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="should-we-use-strict">Should we “use strict”?</h2>
    <p>The question may sound obvious, but it’s not so.</p>
    <p>
      One could recommend to start scripts with <code>"use strict"</code>… But
      you know what’s cool?
    </p>
    <p>
      Modern JavaScript supports “classes” and “modules” - advanced language
      structures (we’ll surely get to them), that enable
      <code>use strict</code> automatically. So we don’t need to add the
      <code>"use strict"</code> directive, if we use them.
    </p>
    <p>
      <strong
        >So, for now <code>"use strict";</code> is a welcome guest at the top of
        your scripts. Later, when your code is all in classes and modules, you
        may omit it.</strong
      >
    </p>
    <p>
      As of now, we’ve got to know about <code>use strict</code> in general.
    </p>
    <p>
      In the next chapters, as we learn language features, we’ll see the
      differences between the strict and old modes. Luckily, there aren’t many
      and they actually make our lives better.
    </p>
    <p>
      All examples in this tutorial assume strict mode unless (very rarely)
      specified otherwise.
    </p>
  </body>
</html>
